

#import <Foundation/Foundation.h>
#import <CoreMIDI/CoreMIDI.h>

@class MIDIDevice;

@protocol MIDIProcessDelegate<NSObject>
@required
- (void) MIDI:(MIDIDevice *)MIDIDevice sourceAdded:(MIDIEndpointRef)source;
- (void) MIDI:(MIDIDevice *)MIDIDevice sourceRemoved:(MIDIEndpointRef)source;
- (void) MIDI:(MIDIDevice *)MIDIDevice destinationAdded:(MIDIEndpointRef)destination;
- (void) MIDI:(MIDIDevice *)MIDIDevice destinationRemoved:(MIDIEndpointRef)destination;
- (void) MIDIReceived:(const MIDIPacketList *)packetList;
@end

@interface MIDIDevice : NSObject
{
    MIDIClientRef             client;
    MIDIPortRef               outputPort;
    MIDIPortRef               inputPort;
    NSMutableArray            *sources;
    NSMutableArray            *destinations;
    
    MIDINotificationMessageID lastNotificationID;
    NSTimer                   *restartTimer;
}

@property (nonatomic, assign) id<MIDIProcessDelegate> delegate;

+ (MIDIDevice *) MIDIDevice; //Get singleton instance
+ (MIDIDevice *) startMIDIMonitor:(id<MIDIProcessDelegate>)deg; //Start MIDI Monitor

- (void) MIDINotify:(const MIDINotification*)notification; //MIDI device changing notification
- (BOOL) isConnect; //Whether external MIDI device is connected
- (void) sendMIDIMsg:(const UInt8*)data Length:(UInt32)size; //Send MIDI Message

@end

