#import "MidiOtgPlugin.h"
#if __has_include(<midi_otg_plugin/midi_otg_plugin-Swift.h>)
#import <midi_otg_plugin/midi_otg_plugin-Swift.h>
#else
// Support project import fallback if the generated compatibility header
// is not copied when this plugin is created as a library.
// https://forums.swift.org/t/swift-static-libraries-dont-copy-generated-objective-c-header/19816
#import "midi_otg_plugin-Swift.h"
#endif




@implementation MidiOtgPlugin

- (instancetype)init
{
    self = [super init];
    if (self) {
        
    }
    return self;
}


+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar> *)registrar {
    
//    FlutterEventChannel *stream =
//            [FlutterEventChannel eventChannelWithName:@"lyokone/locationstream"
//                                      binaryMessenger:registrar.messenger];
//
//    MidiOtgPlugin *instance = [[MidiOtgPlugin alloc] init];
    
    [SwiftMidiOtgPlugin registerWithRegistrar:registrar];
    
    [MIDIDevice startMIDIMonitor:self];
    
    
//    [stream setStreamHandler:instance];
}

#pragma mark- MIDI
// MIDIProcessDelegate
+ (void)MIDI:(MIDIDevice *)MIDIDevice sourceAdded:(MIDIEndpointRef)source {
    CFStringRef name;
    MIDIObjectGetStringProperty(source, kMIDIPropertyDisplayName, &name);
    NSLog(@"===[StrategyUSB]:MIDI Added Device-----:%@", name);
}

+ (void)MIDI:(MIDIDevice *)MIDIDevice sourceRemoved:(MIDIEndpointRef)source {
    CFStringRef name;
    MIDIObjectGetStringProperty(source, kMIDIPropertyDisplayName, &name);
    NSLog(@"===[StrategyUSB]:MIDI Removed Device-----:%@", name);
}

+ (void)MIDI:(MIDIDevice *)MIDIDevice destinationAdded:(MIDIEndpointRef)destination {
    CFStringRef name;
    MIDIObjectGetStringProperty(destination, kMIDIPropertyDisplayName, &name);
    NSLog(@"===[StrategyUSB]:destination Added Device-----:%@", name);
}

+ (void)MIDI:(MIDIDevice *)MIDIDevice destinationRemoved:(MIDIEndpointRef)destination {
    CFStringRef name;
    MIDIObjectGetStringProperty(destination, kMIDIPropertyDisplayName, &name);
    NSLog(@"===[StrategyUSB]:destination Removed Device-----:%@", name);
}

+ (void)MIDIReceived:(const MIDIPacketList *)packetList {
    const MIDIPacket *packet = &packetList->packet[0];
    if (packet->length > 1) {
        
        NSLog(@"StringFromMIDI:%@", StringFromMIDI(packet));
    }
}

NSString * StringFromPacket(const MIDIPacket *packet){
    
    NSLog(@"timeStamp %llu",packet->timeStamp);
    NSLog(@"data %s",packet->data);
    NSLog(@"length %hu",packet->length);
    
    return [NSString stringWithFormat:@"StringFromPacket  %u bytes: [%02x,%02x,%02x,%02x,%02x,%02x]",
            packet->length,
            (packet->length > 0) ? packet->data[0] : 0,
            (packet->length > 1) ? packet->data[1] : 0,
            (packet->length > 2) ? packet->data[2] : 0,
            (packet->length > 3) ? packet->data[3] : 0,
            (packet->length > 4) ? packet->data[4] : 0,
            (packet->length > 5) ? packet->data[5] : 0
    ];
}

NSString * StringFromMIDI(const MIDIPacket *packet){
    return [NSString stringWithFormat:@"StringFromMIDI %02x%02x%02x",
            (packet->length - 2 > 0) ? packet->data[packet->length - 3] : 0,
            (packet->length - 1 > 1) ? packet->data[packet->length - 2] : 0,
            (packet->length > 2) ? packet->data[packet->length - 1] : 0
    ];
}

@end
